
menu = require 'mylib/menu'
require 'game/player'
require 'game/entity'

game = {}
cloud = {}
cloud.x = -90
cloud.y = 100

game.load = function()
	menu1 = menu.new()
	menu1:addItem {
		name = "play squares",
		action = function() gamestate = "game" end
		}
	menu1:addItem {
		name = "quit squares",
		action = function() love.event.quit() end
		}
	entity.new("coin")
	entity.new("enemy")
	love.graphics.setBackgroundColor(95, 255, 255)
	game.score = 0
	game.fakescore = 0
	menuloop = love.audio.newSource("game/music/menuloop.mp3")
	gameloop = love.audio.newSource("game/music/gameloop.mp3")
	fontN = love.graphics.newFont("game/font/coders_crux.ttf", 32)
	fontT = love.graphics.newFont("game/font/coders_crux.ttf", 48)
	menuloop:setLooping(true)
	gameloop:setLooping(true)
	gamestate = "menu"
end
	
game.draw = function()
	if gamestate == "menu" then
		love.graphics.setColor(255, 255, 255)
		love.graphics.setFont(fontT)
		love.graphics.print("squares", love.window.getWidth()/2 - 65, 100)
		love.graphics.setFont(fontN)
		love.graphics.print("version 1b", love.window.getWidth()/2 - 65, 130)
		love.graphics.setColor(50, 170, 50)
		love.graphics.rectangle("fill", 0, 340, love.window.getWidth(), love.window.getHeight())
		menu1:draw(60, 240)
	elseif gamestate == "game" then
		love.graphics.setColor(50, 170, 50)
		love.graphics.rectangle("fill", 0, 340, love.window.getWidth(), love.window.getHeight())
		love.graphics.setColor(255, 255, 255)
		love.graphics.setFont(fontN)
		love.graphics.print("score: " .. game.score, love.window.getWidth()/2 - 50, 370)
		love.graphics.rectangle("fill", cloud.x, cloud.y, 100, 50)
		player.draw()
		entity.draw()
	elseif gamestate == "gameover" then
		love.graphics.setColor(50, 170, 50)
		love.graphics.rectangle("fill", 0, 340, love.window.getWidth(), love.window.getHeight())
		love.graphics.setColor(255, 255, 255)
		love.graphics.setFont(fontT)
		love.graphics.print("game over!",love.window.getWidth()/2 - 85, 100)
	end
end
	
game.update = function(dt)
	if gamestate == "menu" then
		menu1:update(dt)
		gameloop:stop()
		if not menuloop:isPlaying() then
			menuloop:play()
		end
	elseif gamestate == "game" then
		entity.update(dt)
		player.move(dt)
		cloud.x = cloud.x + 50 * dt
		if cloud.x >= love.window.getWidth() + 90 then
			cloud.x = -90
		end
		if game.fakescore == 10 then
			entity.new("enemy")
			entity.new("life")
			entity.new("boost")
			game.fakescore = game.fakescore + 1
		elseif game.fakescore == 21 then
			entity.new("enemy")
			game.fakescore = game.fakescore + 1
		end
		if player.life == 0 then
			gamestate = "gameover" 
		end
	elseif gamestate == "gameover" then
		menuloop:stop()
		player.life = 3
	end
end
	
game.input = function(k)
	menu1:keypressed(k)
	if k == " " and gamestate == "gameover" then
		gamestate = "menu"
	end
end
	
checkCollision = function(x1,y1,w1,h1, x2,y2,w2,h2)
	return x1 < x2+w2 and x2 < x1+w1 and y1 < y2+h2 and y2 < y1+h1
end